<script setup lang="ts">
import { ref, onMounted, watch } from 'vue'
import UserApiV1 from '@/api/userApi'

const gitlab_uri = ref(window.GITLAB_URI)

const usersList = ref([])
const itemsPerPage = ref(20)
const currentPage = ref(1)
const totalRows = ref(0)
const loading = ref(false)

const fields = ref([
  { key: 'name', title: 'Full name' },
  { key: 'username', title: 'User name' },
  { key: 'email', title: 'Email' },
  { key: 'role', title: 'Role' },
  { key: 'internal', title: 'Internal' },
  { key: 'git_lab_user', title: 'GitLab user' },
  { key: 'actions', title: 'Actions', sortable: false },
])

const userApi = new UserApiV1()

// Función para obtener usuarios con paginación
const getUsers = async (itemsPerPage, currentPage) => {
  loading.value = true
  try {
    const response = await userApi.listUsers(itemsPerPage, currentPage)
    totalRows.value = Number.parseInt(response.headers['x-total'])
    usersList.value = response.data.data
  } catch (error) {
    console.error('Error fetching users:', error)
  } finally {
    loading.value = false
  }
}

// Llamar a la API para obtener usuarios cuando el componente se monte
onMounted(() => {
  getUsers(itemsPerPage.value, currentPage.value)
})

// Observar cambios en paginación y volver a cargar datos
watch([itemsPerPage, currentPage], () => {
  getUsers(itemsPerPage.value, currentPage.value)
})

// Llamar a la API cuando cambian los valores de paginación o la página actual
const fetchData = ({ itemsPerPage, page }) => {
  getUsers(itemsPerPage, page)
}

const finished = async () => {
  await getUsers(itemsPerPage.value, currentPage.value)
}
</script>
<template>
  <SettingsTemplate>
    <VRow>
      <VCol
        cols="12"
        class="d-flex justify-end"
      >
        <VBtn
          color="primary"
          :to="{ name: 'settings-user-new' }"
        >
          Add User
        </VBtn>
      </VCol>
    </VRow>

    <VRow class="ma-2">
      <VCol
        cols="12"
        class="d-flex align-center"
      >
        <label class="mr-2">Show</label>
        <VSelect
          v-model="itemsPerPage"
          :items="[5, 10, 20, 50, 100]"
          label="Users per page"
          class="shrink"
        />
      </VCol>
    </VRow>

    <VDataTableServer
      v-model:items-per-page="itemsPerPage"
      v-model:page="currentPage"
      :headers="fields"
      :items="usersList"
      :items-length="totalRows"
      :loading="loading"
      @update:options="fetchData"
    >
      <template #item.name="{ item }">
        <RouterLink :to="{ name: 'settings-user-edit', params: { id: item.id } }">
          {{ `${item.surname_1} ${item.surname_2}, ${item.name}` }}
        </RouterLink>
      </template>

      <template #item.internal="{ item }">
        <VIcon
          :color="item.internal ? 'success' : 'error'"
          :icon="item.internal ? 'tabler-check' : 'tabler-x'"
        />
      </template>

      <template #item.git_lab_user="{ item }">
        <a
          :href="`${gitlab_uri}/admin/users/${item.git_lab_user ? item.git_lab_user.git_username : ''}`"
          target="_blank"
          rel="noopener noreferrer"
          style="text-decoration: none;"
        >
          <VIcon :color="item.git_lab_user ? 'success' : 'error'">
            tabler-brand-gitlab
          </VIcon>
        </a>
      </template>

      <template #item.actions="{ item }">
        <div class="d-flex gap-1">
          <RouterLink :to="{ name: 'settings-user-edit', params: { id: item.id } }">
            <IconBtn @click="">
              <VIcon icon="tabler-edit" />
            </IconBtn>
          </RouterLink>
          <UserDeleteModal
            :user-id="item.id"
            :username="item.username"
            @finished="getUsers"
          />
        </div>
      </template>

    </VDataTableServer>
  </SettingsTemplate>
</template>
